; ##############################################################################
; ##############################################################################
; ##############################################################################
; LISTE (STAM) lschen															
ONE_WIRE_LISTE_CLEAR:
	ldi ZL, LOW (adr_ROM_LISTE)
	ldi ZH, HIGH(adr_ROM_LISTE)
	clr temp
ONE_WIRE_LISTE_CLEAR_s:
	ST z+,NULL
	dec temp
	brne ONE_WIRE_LISTE_CLEAR_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; alle SLAVES aus der "LISTE" (SRAM)  auslesen und TEMPERATUREN berechnen		
;																				
; INP: SRAM (adr_ROM_SLAVE_LISTE)												
; OUT: SRAM	(adr_TEMPERATURTEMPERATURWERTE)										
;																				
ONE_WIRE_LISTE_ABARBEITEN:
	; CLEAR				
	rcall DSXXXX_TEMPERATURTEMPERATURWERTE_CLEAR
	rcall ROM_CLEAR
	rcall DSXXXX_SCRATCHPAD_CLEAR
	STS(adr_SLAVES_LFD_NR),NULL
	STS(adr_ANZAHL_SLAVES),NULL
;-------------------------------------------------------------------------------
ONE_WIRE_LISTE_ABARBEITEN_NEXT:
	ldi ZL,  low(adr_ROM_LISTE)	    ; Z auf LISTE	
	ldi ZH, high(adr_ROM_LISTE)
	ldi XL,  low(adr_ROM_CRC_BEREICH)		; X auf ROM		
	ldi XH, high(adr_ROM_CRC_BEREICH)
	; lfd. NR Slaves		
	LDS temp,(adr_SLAVES_LFD_NR)
	; 8x addieren			
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	; KOPIE														
	LD temp1, Z+		; aus LISTE laden (adr_ROM_SLAVE_LISTE)	
	ST X+,temp1			; ablegen im SRAM (adr_ROM_CRC_BEREICH)	
	LD temp1, Z+		;
	ST X+,temp1			
	LD temp1, Z+		;
	ST X+,temp1			
	LD temp1, Z+		;
	ST X+,temp1			
	LD temp1, Z+		;
	ST X+,temp1			
	LD temp1, Z+		;
	ST X+,temp1			
	LD temp1, Z+		;
	ST X+,temp1			
	LD temp1, Z+		;
	ST X+,temp1			
	; ROM = 0 ??				
	LDS temp,(adr_ROM_CRC_BEREICH+0)
	tst temp
	breq ONE_WIRE_LISTE_ABARBEITEN_FERTIG
	; ROM CRC					
	rcall ONE_WIRE_ROM_CRC7					; OUT: CARRY		
	brcc ONE_WIRE_LISTE_ABARBEITEN_ERROR	; CARRY=0 ==> SPRUNG
	; MESSWERT auslesen			
	rcall DSXXXX_SPEZAIAL_SCRATCHPAD_DIREKT	; OUT: CARRY		
	brcc ONE_WIRE_LISTE_ABARBEITEN_ERROR	; CARRY=0 ==> SPRUNG
	; lfd. NR Slaves + 1		
	LDS temp,(adr_SLAVES_LFD_NR)
	inc temp
	STS(adr_SLAVES_LFD_NR),temp
	STS(adr_ANZAHL_SLAVES),temp
	rjmp ONE_WIRE_LISTE_ABARBEITEN_NEXT
;-------------------------------------------------------------------------------
ONE_WIRE_LISTE_ABARBEITEN_FERTIG:
	; CARRY setzen			
	SEC	
	ret
;-------------------------------------------------------------------------------
ONE_WIRE_LISTE_ABARBEITEN_ERROR:
	; ERROR					
	ldi temp,(ERROR_LISTE_MESSEN)	; CODE				
	rcall ERROR_SPEICHERN			; inp temp (CODE)	
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "TABELLE" (PROGRAMMCODE) NACH "LISTE" (SRAM) KOPIEREN							
ONE_WIRE_LISTE_TABELLE_NACH_LISTE_KOPIEREN:
	ldi ZL,  low(SENSOR_ROM_00*2)		    ; Z auf Tabelle
	ldi ZH, high(SENSOR_ROM_00*2)
	ldi XL,  low(adr_ROM_LISTE)		; X auf LISTE	
	ldi XH, high(adr_ROM_LISTE)
	; SCHLEIFE	
	ldi temp,30
ONE_WIRE_LISTE_TABELLE_NACH_LISTE_KOPIEREN_s:
	adiw XL,8
	LPM temp1, Z+		; aus TABELLE laden	
	ST -X,temp1			; ablegen in SRAM (adr_ROM_SLAVE_LISTE)
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	adiw XL,8
	dec temp
	brne ONE_WIRE_LISTE_TABELLE_NACH_LISTE_KOPIEREN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################









