; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_CLEAR:
	STS(adr_ROM_CRC_BEREICH+0),NULL			; FAMILY	
	STS(adr_ROM_CRC_BEREICH+1),NULL
	STS(adr_ROM_CRC_BEREICH+2),NULL
	STS(adr_ROM_CRC_BEREICH+3),NULL
	STS(adr_ROM_CRC_BEREICH+4),NULL
	STS(adr_ROM_CRC_BEREICH+5),NULL
	STS(adr_ROM_CRC_BEREICH+6),NULL
	STS(adr_ROM_CRC_BEREICH+7),NULL 		; CRC		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_MATCH:
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	LDS temp1,(adr_ROM_CRC_BEREICH+0)			; FAMILY CODE	
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+1)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+2)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+3)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+4)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+5)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+6)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+7)			; CRC			
	rcall ONE_WIRE_DATA_WRITE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ROM_SKIP:
	; MASTER TX xCC (skip ROM)					
	ldi	temp1,0xCC			
	rcall ONE_WIRE_DATA_WRITE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ROM auslesen, nur ein SLAVE vorhanden !										
;																				
; OUT: CARRY, SRAM (adr_ROM_CRC_BEREICH)										
;																				
ROM_READ:
	; CLEAR										
	rcall ROM_CLEAR
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	brcc ROM_READ_ERROR				; CARRY=0 ==> SPRUNG		
	; MASTER TX x33 (read ROM)					
	ldi	temp1,0x33			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 8 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+7),temp1
	; ROM CRC- CHECK							
	rcall ONE_WIRE_ROM_CRC7						; OUT: CARRY		
	brcc ROM_READ_ERROR				; CARRY=0 ==> SPRUNG		
	; CARRY setzen			
	SEC
	ret
;-------------------------------------------------------------------------------
ROM_READ_ERROR:
	; ERROR					
	ldi temp,(ERROR_SINGLE_ROM_READ); CODE				
	rcall ERROR_SPEICHERN			; inp temp (CODE)	
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
