; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;	INP: 		SRAM (adr_ROM_CRC_BEREICH)										
;																				
DS2433_READ_EEPROM:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	brcc DS2433_READ_EEPROM_ERROR
	; MASTER TX x55 (MATCH ROM) +  8 BYTE ROM CODE
	rcall ROM_MATCH
	; MASTER TX xF0(READ MEMORY)							
	ldi	temp1,0xF0
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX x00(TA1)									
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX x00(TA2)									
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 4x10 BYTE 
	rcall LCD_CLEAR
	rcall DS2433_READ_EEPROM_10BYTES
	rcall LCD_ZEILE2
	rcall DS2433_READ_EEPROM_10BYTES
	rcall LCD_ZEILE3
	rcall DS2433_READ_EEPROM_10BYTES
	rcall LCD_ZEILE4
	rcall DS2433_READ_EEPROM_10BYTES
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	brcc DS2433_READ_EEPROM_ERROR
ret
;-------------------------------------------------------------------------------
DS2433_READ_EEPROM_ERROR:
	cbi PORTD,LED_D_ROT						; ROT		
ret
;-------------------------------------------------------------------------------
DS2433_READ_EEPROM_10BYTES:
	ldi temp,10
DS2433_READ_EEPROM_10BYTES_s:
	push temp
	rcall ONE_WIRE_DATA_READ	; OUT: temp1
	rcall LCD_AUSGABE_2_STELLEN_HEX_TEMP1
	pop temp
	dec temp
	brne DS2433_READ_EEPROM_10BYTES_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;	INP: 		SRAM (adr_ROM_CRC_BEREICH)										
;																				
DS2433_WRITE_EEPROM:
;-------------------------------------------------------------------------------
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	;brcc DS2433_WRITE_EEPROM_ERROR
	; MASTER TX x55 (MATCH ROM) +  8 BYTE ROM CODE
	rcall ROM_MATCH
	; MASTER TX x0F (write SCRATCHPAD)					
	ldi	temp1,0x0F
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX (TA1)					
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX (TA2)					
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
;-------------------------------------------------------------------------------
	; MASTER TX (DATA)					
	ldi	temp1,0x12
	rcall ONE_WIRE_DATA_WRITE
	ldi	temp1,0x11
	rcall ONE_WIRE_DATA_WRITE
	ldi	temp1,0x20
	rcall ONE_WIRE_DATA_WRITE
	ldi	temp1,0x11
	rcall ONE_WIRE_DATA_WRITE
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	rcall ONE_WIRE_DATA_WRITE
	rcall ONE_WIRE_DATA_WRITE
	rcall ONE_WIRE_DATA_WRITE
	rcall ONE_WIRE_DATA_WRITE
	rcall ONE_WIRE_DATA_WRITE

	LDS temp1,(adr_ROM_CRC_BEREICH+7)			; CRC			
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+6)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+5)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+4)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+3)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+2)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+1)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+0)			; FAMILY CODE	
	rcall ONE_WIRE_DATA_WRITE
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	rcall ONE_WIRE_DATA_WRITE
;-------------------------------------------------------------------------------
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	brcc DS2433_WRITE_EEPROM_ERROR
	; MASTER TX x55 (MATCH ROM) +  8 BYTE ROM CODE
	rcall ROM_MATCH
	; MASTER TX xAA (read SCRATCHPAD)					
	ldi	temp1,0xAA
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX (TA1)	
	rcall ONE_WIRE_DATA_READ	; OUT: temp1
	; MASTER RX (TA2)	
	rcall ONE_WIRE_DATA_READ	; OUT: temp1
	; MASTER RX (E/S)										(AUORISIERUNG)
	rcall LCD_ZEILE2
	rcall ONE_WIRE_DATA_READ	; OUT: temp1
	push temp1	; sichern
;-------------------------------------------------------------------------------
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	brcc DS2433_WRITE_EEPROM_ERROR
	; MASTER TX x55 (MATCH ROM) +  8 BYTE ROM CODE
	rcall ROM_MATCH
	; MASTER TX x55 (COPPY SCRATCHPAD)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX (TA1)					
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX (TA2)					
	ldi	temp1,0x00
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX  (E/S)										(AUORISIERUNG)
	pop temp1 ; wiederherstellen
	rcall ONE_WIRE_DATA_WRITE
	; STRONG_PULLUP
	rcall ONE_WIRE_STRONG_PULLUP
	rcall wait_1s
ret
;-------------------------------------------------------------------------------
DS2433_WRITE_EEPROM_ERROR:
	cbi PORTD,LED_D_ROT						; ROT		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

