; ##############################################################################
; ##############################################################################
; ##############################################################################
; CLEAR																			
DSXXXX_SCRATCHPAD_CLEAR:
	STS(adr_SCRATCHPAD_CRC_BEREICH+0),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+1),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+2),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+3),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+4),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+5),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+6),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+7),NULL
	STS(adr_SCRATCHPAD_CRC_BEREICH+8),NULL ; CRC		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CLEAR																			
DSXXXX_TEMPERATURTEMPERATURWERTE_CLEAR:
	; Z- ZEIGER		
	ldi ZL,LOW (adr_TEMPERATURTEMPERATURWERTE)
	ldi ZH,HIGH(adr_TEMPERATURTEMPERATURWERTE)	
	; SCHLEIFE		
	ldi temp,60
DSXXXX_TEMPERATURTEMPERATURWERTE_CLEAR_s:
	ST Z+,NULL
	dec temp
	brne DSXXXX_TEMPERATURTEMPERATURWERTE_CLEAR_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ist SLAVE ein TEMPERATURSENSOR ?												
;																				
; INP: SRAM (adr_ROM_CRC_BEREICH+0) FAMILY CODE									
; OUT: CARRY																	
DSXXXX_CHECK_TEMPERATURSENSOR:
	; FAMILY CODE prfen, dann SCRATCHPAD
	LDS temp,(adr_ROM_CRC_BEREICH+0)			; FAMILY CODE	

	cpi temp, 0x10	; x10 DS1820 DS18s20 DS1920	
	breq DSXXXX_CHECK_TEMPERATURSENSOR_OK
	cpi temp, 0x22	; x22 DS1822				
	breq DSXXXX_CHECK_TEMPERATURSENSOR_OK
	cpi temp,0x28	; x28 DS18B20				
	breq DSXXXX_CHECK_TEMPERATURSENSOR_OK
	; CARRY clear								
	CLC
	ret
;-------------------------------------------------------------------------------
DSXXXX_CHECK_TEMPERATURSENSOR_OK:
	; CARRY setzen								
	SEC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD auslesen, meherer SLAVES am BUS, ROM-ID muss bekannt sein			
; Auswahl des BERECHNUNGSVERFAHRENS durch den FAMILY-CODE						
;																				
; inp: SRAM	(adr_ROM_CRC_BEREICH)												
; OUT: temp1+2 (adr_TEMPERATURTEMPERATURWERTE)									
DSXXXX_SCRATCHPAD_TEMPERATURBERECHNUNG:
	; CLEAR																		
	STS(adr_ANZAHL_85GRD_MESSUNGEN),NULL
	rcall DSXXXX_SCRATCHPAD_CLEAR
	; FAMILY prfen (nur bei Temperatursensoren SCRATCHPAD auslesen)			
	rcall DSXXXX_CHECK_TEMPERATURSENSOR	; OUT CARRY					
	brcc DSXXXX_TEMPERATURBERECHNUNG_DUMMY	
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_TEMPERATUR_RUN:
	; SCRATCHPAD auslesen														
	rcall DSXXXX_SCRATCHPAD_READ			; OUT: CARRY				
	brcc DSXXXX_SCRATCHPAD_TEMPERATUR_ERROR; CARRY=0 ==> SPRUNG		
;-------------------------------------------------------------------------------
	; FAMILY laden							
	LDS temp,(adr_ROM_CRC_BEREICH+0)		
	cpi temp,0x10							
	breq DSXXXX_SCRATCHPAD_TEMPERATUR_x10
	cpi temp,0x22					
	breq DSXXXX_SCRATCHPAD_TEMPERATUR_x22
	cpi temp,0x28					
	breq DSXXXX_SCRATCHPAD_TEMPERATUR_x28
	rjmp DSXXXX_SCRATCHPAD_TEMPERATUR_ERROR
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_TEMPERATUR_x10:
	; x10 DS1820 DS18s20 DS1920	
	; WERT als 9 BIT			
	;rcall DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_9BIT
	; WERT als 12 BIT			
	rcall DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A
	brcc DSXXXX_SCRATCHPAD_TEMPERATUR_ERROR; CARRY=0 ==> SPRUNG

	rjmp DSXXXX_TEMPERATURBERECHNUNG_FERTIG
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_TEMPERATUR_x22:
	; x22 DS1822				
	rcall DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_12BIT
	brcc DSXXXX_SCRATCHPAD_TEMPERATUR_ERROR; CARRY=0 ==> SPRUNG

	rjmp DSXXXX_TEMPERATURBERECHNUNG_FERTIG
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_TEMPERATUR_x28:
	; x28 DS18B20				
	; WERT als 9 BIT			
	; rcall DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_9BIT
	; oder WERT als 12 BIT			
	rcall DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A
	brcc DSXXXX_SCRATCHPAD_TEMPERATUR_ERROR; CARRY=0 ==> SPRUNG

	rjmp DSXXXX_TEMPERATURBERECHNUNG_FERTIG
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_TEMPERATUR_ERROR:
	; ERROR																		
	ldi temp,(ERROR_TEMPERATURBERECHNUNG)	; CODE											
	rcall ERROR_SPEICHERN 					; OUT: CARRY=0 									
	; -99,9 C		
	ldi temp1, LOW(-999)
	ldi temp2,HIGH(-999)
	; CARRY clear	
	CLC										
	rjmp DSXXXX_TEMPERATURBERECHNUNG_FERTIG
;-------------------------------------------------------------------------------
DSXXXX_TEMPERATURBERECHNUNG_DUMMY:
	; x14 DS2430A(EEPROM)				
	; x23 DS2433 (EEPROM)				
	; x26 DS2438 Smart Battery Monitor	
	; x27 DS2417 RTC					
	clr temp1
	clr temp2
;-------------------------------------------------------------------------------
DSXXXX_TEMPERATURBERECHNUNG_FERTIG:
	; 85 C (ERROR)
	cpi temp1,LOW(850)
	brne DSXXXX_TEMPERATURBERECHNUNG_FERTIG_OK
	cpi temp2,HIGH(850)
	brne DSXXXX_TEMPERATURBERECHNUNG_FERTIG_OK
	; nochmal messen	
	rcall ONE_WIRE_MESSUNG_ALLE
	; ANZAHL + 1		
	LDS temp,(adr_ANZAHL_85GRD_MESSUNGEN)
	inc temp
	STS(adr_ANZAHL_85GRD_MESSUNGEN),temp
	; wenn Maximalanzahl erreicht, dann ERROR	
	cpi temp,3
	brne DSXXXX_SCRATCHPAD_TEMPERATUR_RUN
	; ERROR																		
	ldi temp,(ERROR_85_GRD)					; CODE											
	rcall ERROR_SPEICHERN 					; OUT: CARRY=0 									
;-------------------------------------------------------------------------------
DSXXXX_TEMPERATURBERECHNUNG_FERTIG_OK:
	; Z-ZEIGER			
	ldi ZL,LOW (adr_TEMPERATURTEMPERATURWERTE)
	ldi ZH,HIGH(adr_TEMPERATURTEMPERATURWERTE)	
	; lfd. NR Slaves	
	LDS temp,(adr_SLAVES_LFD_NR)
	; 2 x addieren		
	add ZL,temp
	adc ZH,NULL
	add ZL,temp
	adc ZH,NULL
	; speichern			
	ST Z+,temp1
	ST Z+,temp2
	; CARRY setzen	
	SEC								
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD auslesen, meherer SLAVES am BUS, ROM-ID muss bekannt sein			
;																				
;	INP: 		SRAM (adr_ROM_CRC_BEREICH)										
;	OUT: CARRY, SRAM (adr_SCRATCHPAD_CRC_BEREICH)								
;																				
DSXXXX_SCRATCHPAD_READ:
	; CLEAR										
	rcall DSXXXX_SCRATCHPAD_CLEAR
	; FAMILY prfen								
	rcall DSXXXX_CHECK_TEMPERATURSENSOR		; OUT CARRY	
	brcs DSXXXX_SCRATCHPAD_READ_RUN
	; CARRY clear								
	CLC
	ret
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_READ_RUN:
	; CRC- CHECK (der zu sendende ROM-ID)		
	rcall ONE_WIRE_ROM_CRC7						; OUT: CARRY
	brcc DSXXXX_SCRATCHPAD_READ_ERROR			; CARRY=0 ==> SPRUNG		
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY				
	brcc DSXXXX_SCRATCHPAD_READ_ERROR			; CARRY=0 ==> SPRUNG		
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	LDS temp1,(adr_ROM_CRC_BEREICH+0)			; FAMILY CODE	
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+1)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+2)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+3)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+4)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+5)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+6)			; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+7)			; CRC			
	rcall ONE_WIRE_DATA_WRITE
;-------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_READ_SINGLE_MARKE:
	; MASTER TX xBE (read SCRATCHPAD)					
	ldi	temp1,0xBE			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 9 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+7),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_SCRATCHPAD_CRC_BEREICH+8),temp1
	; CRC CHECK													
	rcall ONE_WIRE_SCRATCHPAD_CRC8	; OUT: (CRC)				
	brcc DSXXXX_SCRATCHPAD_READ_ERROR	; CARRY=0 ==> SPRUNG		
	; CARRY setzen								
	SEC
	ret
;----------------------------------------------------------------------------------
DSXXXX_SCRATCHPAD_READ_ERROR:
	; ERROR					
	ldi temp,(ERROR_SCRATCHPAD_READ)	; CODE				
	rcall ERROR_SPEICHERN				; inp temp (CODE)	
	; CARRY clear								
	CLC	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung der Temperatur mit 0,1 GRD GENAUIGKEIT								
;																				
; +125      C ===> 0x07D0														
;  +85      C*===> 0x0550														
;  +25.0625 C ===> 0x0191														
;  +10.125  C ===> 0x00A2														
;   +0.5    C ===> 0x0008														
;    0      C ===> 0x0000														
;   -0.5    C ===> 0xFFF8														
;  -10.125  C ===> 0xFF5E														
;  -25.0625 C ===> 0xFE6F														
;  -55      C ===> 0xFC90														
;																				
; inp: SRAM (adr_SCRATCHPAD_CRC_BEREICH)										
; OUT: temp1+2																	
;																				
DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_12BIT:
	; aus SRAM laden		
	LDS temp1,(adr_SCRATCHPAD_CRC_BEREICH+0)	; aus SRAM laden	
	LDS temp2,(adr_SCRATCHPAD_CRC_BEREICH+1)
;----------------------------------------------------------------------------------
	; TESTZAHLEN (+125)		
	;ldi temp1, low (0x07D0)	
	;ldi temp2, HIGH(0x07D0)
	; TESTZAHLEN (+85)		
	;ldi temp1, low (0x0550)	
	;ldi temp2, HIGH(0x0550)
	; TESTZAHLEN (+0,5)		
	;ldi temp1, low (0x0008)	
	;ldi temp2, HIGH(0x0008)
	; TESTZAHLEN (-0,5)		
	;ldi temp1, low (0xFFF8)	
	;ldi temp2, HIGH(0xFFF8)
	; TESTZAHLEN (-10.125)		
	;ldi temp1, low (0xFF5E)	
	;ldi temp2, HIGH(0xFF5E)
;-------------------------------------------------------------------------------

	; mal 5 (4 mal addieren)			
	mov temp3,temp1
	mov temp4,temp2
	add temp1,temp3	; x2
	adc temp2,temp4
	add temp1,temp3	; x3
	adc temp2,temp4
	add temp1,temp3	; x4
	adc temp2,temp4
	add temp1,temp3	; x5
	adc temp2,temp4
	; aufrunden+4				
	subi temp1,LOW (-4)	
	sbci temp2,HIGH(-4)
	; : 8 (mit 3x Arithmetisch rechts)
	ASR temp2			; :2 (:2)	
	ROR temp1
	ASR temp2			; :2 (:4)	
	ROR temp1
	ASR temp2			; :2 (:8)	
	ROR temp1
	; CARRY setzen			
	SEC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung der Temperatur mit 0,5 GRD GENAUIGKEIT								
;																				
; +85.0C ===> 0x00AA															
; +25.0C ===> 0x0032															
;  +0.5C ===> 0x0001															
;     0C ===> 0x0000															
;  -0.5C ===> 0xFFFF															
; -25.0C ===> 0xFFCE															
; -55.0C ===> 0xFF92															
;																				
; inp: SRAM (adr_SCRATCHPAD_CRC_BEREICH)										
; OUT: temp1+2																	
;																				
DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_9BIT:
	; aus SRAM laden		
	LDS temp1,(adr_SCRATCHPAD_CRC_BEREICH+0)	
	LDS temp2,(adr_SCRATCHPAD_CRC_BEREICH+1)
;----------------------------------------------------------------------------------
	; TESTZAHLEN (-0,5)		
	;ldi temp1, low (0xFFFF)	
	;ldi temp2, HIGH(0xFFFF)
	; TESTZAHLEN (-25)		
	;ldi temp1, low (0xFFCE)	
	;ldi temp2, HIGH(0xFFCE)
	; TESTZAHLEN (+25)		
	;ldi temp1, low (0x0032)	
	;ldi temp2, HIGH(0x0032)
;----------------------------------------------------------------------------------
	ldi temp,5 					; mal 5			
	mulsu temp1,temp
	mov temp1,R0				; Kopie			
	mov temp2,R1
	SEC							; CARRY setzen	
;----------------------------------------------------------------------------------
	; Test-Ergebnisse			
	STS(adr_TEMPERATURTEMPERATURWERTE+2),temp1
	STS(adr_TEMPERATURTEMPERATURWERTE+3),temp2
;----------------------------------------------------------------------------------
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Berechnung der Temperatur mit 0,1 GRD GENAUIGKEIT								
;																				
; TEMPERATUR= TEMP_READ - 0,25 + ((COUNT_PER_C - COUNT_REMAIN)/COUNT_PER_C)		
;																				
; COUNT_PER_C ist immer 16 !													
;																				
; TEMPERATUR= TEMP_READ - 0,25 + ((16 - COUNT_REMAIN)/16)						
;																				
; mit 160 erweitern:															
;																				
; 160*TEMPERATUR= (160*TEMP_READ)-(160*0,25)+ 160*((16 - COUNT_REMAIN)/16)		
;																				
; vereinfachen:																	
;																				
; 160*TEMPERATUR= (160*TEMP_READ)-(40)+ 10*(16 - COUNT_REMAIN)					
;																				
; durch 16 (ergibt 0,1GRD)														
;																				
; 10*TEMPERATUR= ((160*TEMP_READ)-(40)+ 10*(16 - COUNT_REMAIN))/16				
;																				
; +85.0C ===> 0x00AA															
; +25.0C ===> 0x0032															
;  +0.5C ===> 0x0001															
;     0C ===> 0x0000															
;  -0.5C ===> 0xFFFF															
; -25.0C ===> 0xFFCE															
; -55.0C ===> 0xFF92															
;																				
;																				
; inp: SRAM (adr_SCRATCHPAD_CRC_BEREICH)										
; OUT: temp1+2																	
;																				
DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A:
	; BIT 7 muss x10 sein				
	LDS temp,(adr_SCRATCHPAD_CRC_BEREICH+7)
	cpi temp,0x10
	breq DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A_RUN
;----------------------------------------------------------------------------------
	; ERROR																		
	ldi temp,(ERROR_TEMPERATURBERECHNUNG_VA); CODE											
	rcall ERROR_SPEICHERN 					; OUT: CARRY=0 									
	; CARRY clear				
	CLC
	ret
;----------------------------------------------------------------------------------
DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A_RUN:
	; aus SRAM laden					
	LDS temp1,(adr_SCRATCHPAD_CRC_BEREICH+0)	
	LDS temp2,(adr_SCRATCHPAD_CRC_BEREICH+1)	
	LDS temp6,(adr_SCRATCHPAD_CRC_BEREICH+6)
;----------------------------------------------------------------------------------
	; TESTZAHLEN (-0,5)		
	;ldi temp1, low (0xFFFF)	
	;ldi temp2, HIGH(0xFFFF)
	; TESTZAHLEN (-25)		
	;ldi temp1, low (0xFFCE)	
	;ldi temp2, HIGH(0xFFCE)
	; TESTZAHLEN (+25)		
	;ldi temp1, low (0x0032)	
	;ldi temp2, HIGH(0x0032)
	; TESTZAHL-Kommastelle	
	;ldi temp6,4		; 4  => KOMMA 5
	;ldi temp6,12	; 12 => KOMMA 0
	; TEST-ERGEBNISSE			
	;STS(adr_TEMPERATURTEMPERATURWERTE+4),temp6
	;STS(adr_TEMPERATURTEMPERATURWERTE+5),NULL
;----------------------------------------------------------------------------------
	; negativ ?							
	tst temp2
	brmi DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A_NEGATIV 
	rjmp DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A_POSITIV
;===================================================================================
DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A_NEGATIV:
	sbrc temp1,0
	dec temp1
	; 1*rechts BIT 0 clear (0,5 GRD ignorieren)	
	SEC
	ROR temp1
	; x 160						
	ldi temp,160
	mulsu temp1,temp
	mov temp1,R0				; Kopie			
	mov temp2,R1	
	rjmp ONE_WIRE_TEMPERATURBERECHNUNG_VARIANTE_A_POSITIV_w
;----------------------------------------------------------------------------------
DSXXXX_TEMPERATURBERECHNUNG_VARIANTE_A_POSITIV:
	; 1*rechts BIT 0 clear (0,5 GRD ignorieren)	
	LSR temp1	
	; x 160						
	ldi temp,160
	mul temp1,temp
	mov temp1,R0				; Kopie			
	mov temp2,R1
ONE_WIRE_TEMPERATURBERECHNUNG_VARIANTE_A_POSITIV_w:
	; -40						
	subi temp1,LOW (40)	
	sbci temp2,HIGH(40)
	; "COUNT_REMAIN" berechnen	
	; 16-(COUNT_REMAIN)			
	ldi temp,16
	sub temp,temp6
	mov temp6,temp
	; x 10				
	ldi temp,10
	MUL temp6,temp
	mov temp6,R0				; Kopie			
	; addieren					
	add temp1,temp6
	adc temp2,NULL
	; aufrunden+8				
	subi temp1,LOW (-8)	
	sbci temp2,HIGH(-8)
	; : 16 (mit Arithmetisch rechts)
	ASR temp2			; :2 (:2)	
	ROR temp1
	ASR temp2			; :2 (:4)	
	ROR temp1
	ASR temp2			; :2 (:8)	
	ROR temp1
	ASR temp2			; :2 (:16)	
	ROR temp1
	; CARRY setzen			
	SEC
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
