; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur einen SLAVES zum messen auffordern										
;																				
;	INP: SRAM (adr_ROM_CRC_BEREICH)												
; 	OUT: CARRY																	
ONE_WIRE_MESSEN_DIREKT:
	; CRC- CHECK (der zu sendende ROM-ID)		
	rcall ONE_WIRE_ROM_CRC7					; OUT: CARRY				
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR		; CARRY=0 ==> SPRUNG		
	; FAMILY prfen								
	rcall DSXXXX_CHECK_TEMPERATURSENSOR		; OUT CARRY					
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR		; CARRY=0 ==> SPRUNG		
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE			; OUT: CARRY				
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR				; CARRY=0 ==> SPRUNG		
	; MASTER TX x55 (MATCH ROM) +  8 BYTE ROM CODE
	rcall ROM_MATCH
	rjmp ONE_WIRE_MESSUNG_ALLE_EINSPRUNGMARKE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; alle SLAVES zum Messen auffordern, Achtung Spannung am SENSOR bricht ein		
; bei zuvielen Sensoren und ungnstigen Kabelverhltnissen						
;																				
; OUT: CARRY																	
ONE_WIRE_MESSUNG_ALLE:
	;Reset und Presence-Test					
	rcall ONE_WIRE_RESET_PRESENCE			; OUT: CARRY				
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR				; CARRY=0 ==> SPRUNG		
	; MASTER TX xCC (skip ROM)					
	rcall ROM_SKIP
;-------------------------------------------------------------------------------
ONE_WIRE_MESSUNG_ALLE_EINSPRUNGMARKE:
	; MASTER TX x44 (convert T)					
	ldi	temp1,0x44
	rcall ONE_WIRE_DATA_WRITE	
	; voll POWER (strong pullup )				
	rcall ONE_WIRE_STRONG_PULLUP
	; CARRY setzen								
	SEC
	ret
;-------------------------------------------------------------------------------
ONE_WIRE_MESSUNG_ALLE_ERROR:
	; ERROR					
	ldi temp,(ERROR_MESSEN)					; CODE				
	rcall ERROR_SPEICHERN					; inp temp (CODE)	
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
