; ##############################################################################
; ##############################################################################
; ##############################################################################
; Watchdog aktivieren (max. Zeit)												
WDR_INITIALISIERUNG:

	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
; ENDLOS SCHLEIFE
PROGRAMM_CHECK_FEHLER:
	cbi PORTD,LED_D_ROT		; ROT	
	rcall wait_100ms
	sbi PORTD,LED_D_ROT		; ROT	
	rcall wait_100ms
rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 30 x TABELLEN-EINTRGE auf CRC prfen											
CHECK_TABELLE:
	ldi ZL,  low(SENSOR_ROM_00*2)		; Z auf Tabelle			
	ldi ZH, high(SENSOR_ROM_00*2)


	ldi temp,30
CHECK_TABELLE_s:
	ldi XL,  low(adr_ROM_CRC_BEREICH+8)	; X auf ROM-CRC-BEREICH
	ldi XH, high(adr_ROM_CRC_BEREICH+8)

	LPM temp1, Z+	; laden		
	ST -X,temp1		; speichern	
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	LPM temp1, Z+
	ST -X,temp1
	; CRC	
	rcall ONE_WIRE_ROM_CRC7
	brcs CHECK_TABELLE_OK
	; ERROR	
	ldi temp,(ERROR_TABELLE); CODE				
	rcall ERROR_SPEICHERN	; inp temp (CODE)	
	ret
CHECK_TABELLE_OK:
	adiw XL,8
	dec temp
	brne CHECK_TABELLE_s
	; CLEAR		
	rcall ROM_CLEAR
	rcall DSXXXX_SCRATCHPAD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; erster auftretender FEHLER wird gespeichert									
; INP: temp																		
; OUT: CARRY, LED(ROT), SRAM (adr_ERROR_CODE)									
;																				
;BEISPIEL:																		
;	; ERROR																		
;	ldi temp,(ERROR_CRC_ROM)	; CODE											
;	rcall ERROR_SPEICHERN 		; OUT: CARRY=0 									
;																				
ERROR_SPEICHERN:
	push temp					; sichern			
	LDS temp,(adr_ERROR_CODE)
	tst temp
	breq ERROR_SPEICHERN_RUN
	pop temp					; wiederherstellen	
	; CARRY clear			
	CLC
	ret
;-------------------------------------------------------------------------------
ERROR_SPEICHERN_RUN:
	pop temp					; wiederherstellen	
	; ERROR CODE	
	STS(adr_ERROR_CODE),temp	; speichern
	; ROM			
	LDS temp,(adr_ROM_CRC_BEREICH+7)		; MSB (CRC)		
	STS(adr_ERROR_ROM_ID+7),temp
	LDS temp,(adr_ROM_CRC_BEREICH+6)		;
	STS(adr_ERROR_ROM_ID+6),temp
	LDS temp,(adr_ROM_CRC_BEREICH+5)		;
	STS(adr_ERROR_ROM_ID+5),temp
	LDS temp,(adr_ROM_CRC_BEREICH+4)		;
	STS(adr_ERROR_ROM_ID+4),temp
	LDS temp,(adr_ROM_CRC_BEREICH+3)		;
	STS(adr_ERROR_ROM_ID+3),temp
	LDS temp,(adr_ROM_CRC_BEREICH+2)		;
	STS(adr_ERROR_ROM_ID+2),temp
	LDS temp,(adr_ROM_CRC_BEREICH+1)		;
	STS(adr_ERROR_ROM_ID+1),temp
	LDS temp,(adr_ROM_CRC_BEREICH+0)		; LSB (Family CODE)
	STS(adr_ERROR_ROM_ID+0),temp
	; ROT					
	cbi PORTD,LED_D_ROT		
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
